#
# bash-common-api:jq/load-vars-from-json.jq
#
module {
  "name": "load-vars-from-json",
  "description": "Helper to load bash variables for JSON code",
# "homepage": "https://xxx",
# "license": "xxx",
# "author": "Auteur",
# "repository": {
#   "type": "git",
#   "url": "https://xxx"
# }
};

def load_vars_from_json_string:
  to_entries[] |
  select( .key | contains( "@" ) | not ) | # Ignore all keys like "VARNAME@DISABLED"
  .key as $KEY |
  (
    .value |
    if type == "null" then
      if $MESSAGE_API_SHOW_DEBUG == "true" then
        debug( {"WARNING": "null found", "K": $KEY, "V": . } )
      end |
      null
    elif type == "array" then
      if $MESSAGE_API_SHOW_DEBUG == "true" then
        debug( {"WARNING": "Array detected", "K": $KEY, "V": . } )
      end |
      tojson |
      tostring
    else
      tostring
    end
  ) as $VALUE |
  (
    .value | type == "null"
  ) as $NULLVALUE |
  [
    ["declare", "__JQ_K__=" + $KEY],
    ["declare", "__JQ_V__=" + $VALUE],
    ["declare", "__JQ_N__=" + ($NULLVALUE | tostring)],
    ["__jq_load_vars_from_json_string_load_var__"],
    ["__jq_load_vars_from_json_string_exit_on_error__"],
    ["unset","__JQ_N__"],
    ["unset","__JQ_V__"],
    ["unset","__JQ_K__"]
  ]
  ;

def load_vars_from_json_string_v1_alpha:
  to_entries[] |
  select( .key | contains( "@" ) | not ) | # Ignore all keys like "VARNAME@DISABLED"
  .key as $KEY |
  (
    .value |
    if type == "null" then
      debug( {"WARNING": "null found", "K": $KEY, "V": . } ) |
      null
    elif type == "array" then
      debug( {"WARNING": "Array detected", "K": $KEY, "V": . } ) |
      tojson |
      tostring
    else
      tostring
    end
  ) as $VALUE |
  (
    .value | type == "null"
  ) as $NULLVALUE |
  "__JQ_K__=" + $KEY + "\n"
  +
  "__JQ_V__=" + $VALUE + "\n"
  +
  "__JQ_N__=" + ($NULLVALUE | tostring) + "\n"
  +
  "__jq_load_vars_from_json_string_load_var__\n"
  +
  "__jq_load_vars_from_json_string_exit_on_error__\n"
  +
  "unset __JQ_N__\n"
  +
  "unset __JQ_V__\n"
  +
  "unset __JQ_K__\n"
  ;
